/* 
 *	Copyright (C) 2005 Media Portal
 *	http://mediaportal.sourceforge.net
 *
 *  This Program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *   
 *  This Program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *   
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Make; see the file COPYING.  If not, write to
 *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. 
 *  http://www.gnu.org/copyleft/gpl.html
 *
 */
using System;

namespace DShowNET
{
	/// <summary>
	/// Summary description for TunerCountry.
	/// </summary>
	public class TunerCountry
	{
		public int Id;
		public string Country;

		public TunerCountry(int id, string country)
		{
			this.Id = id;
			this.Country = country;
		}

		public override string ToString()
		{
			return Country;
		}
	}

	public class TunerCountries
	{
		public static TunerCountry[] Countries = new TunerCountry[] 
		{
			new TunerCountry(1,    "USA"),
			new TunerCountry(1,    "Anguilla"),
			new TunerCountry(1,    "Antigua"),
			new TunerCountry(1,    "Bahamas"),
			new TunerCountry(1,    "Barbados"),
			new TunerCountry(1,    "Bermuda"),
			new TunerCountry(1,    "British Virgin Islands"),
			new TunerCountry(1,    "Canada"),
			new TunerCountry(1,    "Cayman Islands"),
			new TunerCountry(1,    "Dominica"),
			new TunerCountry(1,    "Dominican Republic"),
			new TunerCountry(1,    "Grenada"),
			new TunerCountry(1,    "Jamaica"),
			new TunerCountry(1,    "Montserrat"),
			new TunerCountry(1,    "Nevis"),
			new TunerCountry(1,    "St. Kitts"),
			new TunerCountry(1,    "St. Vincent and the Grenadines"),
			new TunerCountry(1,    "Trinidad and Tobago"),
			new TunerCountry(1,    "Turks and Caicos Islands"),
			new TunerCountry(1,    "Barbuda"),
			new TunerCountry(1,    "Puerto Rico"),
			new TunerCountry(1,    "Saint Lucia"),
			new TunerCountry(1,    "United States Virgin Islands"),
			new TunerCountry(2,    "Canada"),
			new TunerCountry(20,   "Egypt"),
			new TunerCountry(212,  "Morocco"),
			new TunerCountry(213,  "Algeria"),
			new TunerCountry(216,  "Tunisia"),
			new TunerCountry(218,  "Libya"),
			new TunerCountry(220,  "Gambia"),
			new TunerCountry(221,  "Senegal Republic"),
			new TunerCountry(222,  "Mauritania"),
			new TunerCountry(223,  "Mali"),
			new TunerCountry(224,  "Guinea"),
			new TunerCountry(225,  "Cote D'Ivoire"),
			new TunerCountry(226,  "Burkina Faso"),
			new TunerCountry(227,  "Niger"),
			new TunerCountry(228,  "Togo"),
			new TunerCountry(229,  "Benin"),
			new TunerCountry(230,  "Mauritius"),
			new TunerCountry(231,  "Liberia"),
			new TunerCountry(232,  "Sierra Leone"),
			new TunerCountry(233,  "Ghana"),
			new TunerCountry(234,  "Nigeria"),
			new TunerCountry(235,  "Chad"),
			new TunerCountry(236,  "Central African Republic"),
			new TunerCountry(237,  "Cameroon"),
			new TunerCountry(238,  "Cape Verde Islands"),
			new TunerCountry(239,  "Sao Tome and Principe"),
			new TunerCountry(240,  "Equatorial Guinea"),
			new TunerCountry(241,  "Gabon"),
			new TunerCountry(242,  "Congo"),
			new TunerCountry(243,  "Congo(DRC)"),
			new TunerCountry(244,  "Angola"),
			new TunerCountry(245,  "Guinea-Bissau"),
			new TunerCountry(246,  "Diego Garcia"),
			new TunerCountry(247,  "Ascension Island"),
			new TunerCountry(248,  "Seychelle Islands"),
			new TunerCountry(249,  "Sudan"),
			new TunerCountry(250,  "Rwanda"),
			new TunerCountry(251,  "Ethiopia"),
			new TunerCountry(252,  "Somalia"),
			new TunerCountry(253,  "Djibouti"),
			new TunerCountry(254,  "Kenya"),
			new TunerCountry(255,  "Tanzania"),
			new TunerCountry(256,  "Uganda"),
			new TunerCountry(257,  "Burundi"),
			new TunerCountry(258,  "Mozambique"),
			new TunerCountry(260,  "Zambia"),
			new TunerCountry(261,  "Madagascar"),
			new TunerCountry(262,  "Reunion Island"),
			new TunerCountry(263,  "Zimbabwe"),
			new TunerCountry(264,  "Namibia"),
			new TunerCountry(265,  "Malawi"),
			new TunerCountry(266,  "Lesotho"),
			new TunerCountry(267,  "Botswana"),
			new TunerCountry(268,  "Swaziland"),
			new TunerCountry(269,  "Mayotte Island"),
			new TunerCountry(269,  "Comoros"),
			new TunerCountry(27,   "South Africa"),
			new TunerCountry(290,  "St. Helena"),
			new TunerCountry(291,  "Eritrea"),
			new TunerCountry(297,  "Aruba"),
			new TunerCountry(298,  "Faroe Islands"),
			new TunerCountry(299,  "Greenland"),
			new TunerCountry(30,   "Greece"),
			new TunerCountry(31,   "Netherlands"),
			new TunerCountry(32,   "Belgium"),
			new TunerCountry(33,   "France"),
			new TunerCountry(34,   "Spain"),
			new TunerCountry(350,  "Gibraltar"),
			new TunerCountry(351,  "Portugal"),
			new TunerCountry(352,  "Luxembourg"),
			new TunerCountry(353,  "Ireland"),
			new TunerCountry(354,  "Iceland"),
			new TunerCountry(355,  "Albania"),
			new TunerCountry(356,  "Malta"),
			new TunerCountry(357,  "Cyprus"),
			new TunerCountry(358,  "Finland"),
			new TunerCountry(359,  "Bulgaria"),
			new TunerCountry(36,   "Hungary"),
			new TunerCountry(370,  "Lithuania"),
			new TunerCountry(371,  "Latvia"),
			new TunerCountry(372,  "Estonia"),
			new TunerCountry(373,  "Moldova"),
			new TunerCountry(374,  "Armenia"),
			new TunerCountry(375,  "Belarus"),
			new TunerCountry(376,  "Andorra"),
			new TunerCountry(377,  "Monaco"),
			new TunerCountry(378,  "San Marino"),
			new TunerCountry(380,  "Ukraine"),
			new TunerCountry(381,  "Serbia and Montenegro"),
			new TunerCountry(385,  "Croatia"),
			new TunerCountry(386,  "Slovenia"),
			new TunerCountry(387,  "Bosnia and Herzegovina"),
			new TunerCountry(389,  "F.Y.R.O.M. (Former Yugoslav Republic of Macedonia)"),
			new TunerCountry(39,   "Italy"),
			new TunerCountry(39,   "Vatican City"),
			new TunerCountry(40,   "Romania"),
			new TunerCountry(41,   "Switzerland"),
			new TunerCountry(41,   "Liechtenstein"),
			new TunerCountry(420,  "Czech Republic"),
			new TunerCountry(421,  "Slovak Republic"),
			new TunerCountry(43,   "Austria"),
			new TunerCountry(44,   "United Kingdom"),
			new TunerCountry(45,   "Denmark"),
			new TunerCountry(46,   "Sweden"),
			new TunerCountry(47,   "Norway"),
			new TunerCountry(48,   "Poland"),
			new TunerCountry(49,   "Germany"),
			new TunerCountry(500,  "Falkland Islands (Islas Malvinas)"),
			new TunerCountry(501,  "Belize"),
			new TunerCountry(502,  "Guatemala"),
			new TunerCountry(503,  "El Salvador"),
			new TunerCountry(504,  "Honduras"),
			new TunerCountry(505,  "Nicaragua"),
			new TunerCountry(506,  "Costa Rica"),
			new TunerCountry(507,  "Panama"),
			new TunerCountry(508,  "St. Pierre and Miquelon"),
			new TunerCountry(509,  "Haiti"),
			new TunerCountry(51,   "Peru"),
			new TunerCountry(52,   "Mexico"),
			new TunerCountry(53,   "Cuba"),
			new TunerCountry(53,   "Guantanamo Bay"),
			new TunerCountry(54,   "Argentina"),
			new TunerCountry(55,   "Brazil"),
			new TunerCountry(56,   "Chile"),
			new TunerCountry(57,   "Colombia"),
			new TunerCountry(58,   "Bolivarian Republic of Venezuela"),
			new TunerCountry(590,  "Guadeloupe"),
			new TunerCountry(590,  "French Antilles"),
			new TunerCountry(591,  "Bolivia"),
			new TunerCountry(592,  "Guyana"),
			new TunerCountry(593,  "Ecuador"),
			new TunerCountry(594,  "French Guiana"),
			new TunerCountry(595,  "Paraguay"),
			new TunerCountry(596,  "Martinique"),
			new TunerCountry(597,  "Suriname"),
			new TunerCountry(598,  "Uruguay"),
			new TunerCountry(599,  "Netherlands Antilles"),
			new TunerCountry(60,   "Malaysia"),
			new TunerCountry(61,   "Australia"),
			new TunerCountry(61,   "Cocos-Keeling Islands"),
			new TunerCountry(62,   "Indonesia"),
			new TunerCountry(63,   "Philippines"),
			new TunerCountry(64,   "New Zealand"),
			new TunerCountry(65,   "Singapore"),
			new TunerCountry(66,   "Thailand"),
			new TunerCountry(670,  "Saipan Island"),
			new TunerCountry(670,  "Rota Island"),
			new TunerCountry(670,  "Tinian Island"),
			new TunerCountry(671,  "Guam"),
			new TunerCountry(672,  "Christmas Island"),
			new TunerCountry(672,  "Australian Antarctic Territory"),
			new TunerCountry(672,  "Norfolk Island"),
			new TunerCountry(673,  "Brunei"),
			new TunerCountry(674,  "Nauru"),
			new TunerCountry(675,  "Papua New Guinea"),
			new TunerCountry(676,  "Tonga"),
			new TunerCountry(677,  "Solomon Islands"),
			new TunerCountry(678,  "Vanuatu"),
			new TunerCountry(679,  "Fiji Islands"),
			new TunerCountry(680,  "Palau"),
			new TunerCountry(681,  "Wallis and Futuna Islands"),
			new TunerCountry(682,  "Cook Islands"),
			new TunerCountry(683,  "Niue"),
			new TunerCountry(684,  "Territory of American Samoa"),
			new TunerCountry(685,  "Samoa"),
			new TunerCountry(686,  "Kiribati Republic"),
			new TunerCountry(687,  "New Caledonia"),
			new TunerCountry(688,  "Tuvalu"),
			new TunerCountry(689,  "French Polynesia"),
			new TunerCountry(690,  "Tokelau"),
			new TunerCountry(691,  "Micronesia"),
			new TunerCountry(692,  "Marshall Islands"),
			new TunerCountry(7,    "Russia"),
			new TunerCountry(7,    "Kazakhstan"),
			new TunerCountry(7,    "Kyrgyzstan"),
			new TunerCountry(7,    "Tajikistan"),
			new TunerCountry(7,    "Turkmenistan"),
			new TunerCountry(7,    "Uzbekistan"),
			new TunerCountry(81,  "Japan"),
			new TunerCountry(82,   "Korea (South)"),
			new TunerCountry(84,   "Vietnam"),
			new TunerCountry(850,  "Korea (North)"),
			new TunerCountry(852,  "Hong Kong SAR"),
			new TunerCountry(853,  "Macao SAR"),
			new TunerCountry(855,  "Cambodia"),
			new TunerCountry(856,  "Laos"),
			new TunerCountry(86,   "China"),
			new TunerCountry(871,  "INMARSAT (Atlantic-East)"),
			new TunerCountry(872,  "INMARSAT (Pacific)"),
			new TunerCountry(873,  "INMARSAT (Indian)"),
			new TunerCountry(874,  "INMARSAT (Atlantic-West)"),
			new TunerCountry(880,  "Bangladesh"),
			new TunerCountry(886,  "Taiwan"),
			new TunerCountry(90,   "Turkey"),
			new TunerCountry(91,   "India"),
			new TunerCountry(92,   "Pakistan"),
			new TunerCountry(93,   "Afghanistan"),
			new TunerCountry(94,   "Sri Lanka"),
			new TunerCountry(95,   "Myanmar"),
			new TunerCountry(960,  "Maldives"),
			new TunerCountry(961,  "Lebanon"),
			new TunerCountry(962,  "Jordan"),
			new TunerCountry(963,  "Syria"),
			new TunerCountry(964,  "Iraq"),
			new TunerCountry(965,  "Kuwait"),
			new TunerCountry(966,  "Saudi Arabia"),
			new TunerCountry(967,  "Yemen"),
			new TunerCountry(968,  "Oman"),
			new TunerCountry(971,  "United Arab Emirates"),
			new TunerCountry(972,  "Israel"),
			new TunerCountry(973,  "Bahrain"),
			new TunerCountry(974,  "Qatar"),
			new TunerCountry(975,  "Bhutan"),
			new TunerCountry(976,  "Mongolia"),
			new TunerCountry(977,  "Nepal"),
			new TunerCountry(98,   "Iran"),
			new TunerCountry(994,  "Azerbaijan"),
			new TunerCountry(995,  "Georgia")
		};
	}
}
