using System;
using System.Collections;
using System.Xml;
using MediaPortal.GUI.Library;

namespace WindowPlugins.GUISettings.Wizard.Analog
{
	/// <summary>
	/// Summary description for GUIWizardAnalogcountry.
	/// </summary>
	public class GUIWizardAnalogcountry:GUIWindow, IComparer
	{
		[SkinControlAttribute(24)]			protected GUIListControl listCountries=null;
		[SkinControlAttribute(23)]			protected GUIButtonControl btnManual=null;
		public GUIWizardAnalogcountry()
		{
			GetID=(int)GUIWindow.Window.WINDOW_WIZARD_ANALOG_COUNTRY;
		}
    
		public override bool Init()
		{
			return Load (GUIGraphicsContext.Skin+@"\wizard_tvcard_analog_country.xml");
		}
		protected override void OnPageLoad()
		{
			base.OnPageLoad ();
			LoadCountries();
		}

		void LoadCountries()
		{
			listCountries.Clear();
			XmlDocument doc= new XmlDocument();
			doc = new XmlDocument();
			doc.Load("http://mediaportal.sourceforge.net/tvsetup/setup.xml");
			XmlNodeList countries = doc.DocumentElement.SelectNodes("/mediaportal/country");
			foreach (XmlNode nodeCountry in countries)
			{
				XmlNode nodeCountryName = nodeCountry.Attributes.GetNamedItem("name");
				XmlNode nodeCountryCode = nodeCountry.Attributes.GetNamedItem("code");
				GUIListItem item = new GUIListItem();
				item.IsFolder=false;
				item.Label=nodeCountryName.Value;
				item.ItemId=Int32.Parse(nodeCountryCode.Value);
				listCountries.Add(item);
			}
			listCountries.Sort(this);
		}
		protected override void OnClicked(int controlId, GUIControl control, MediaPortal.GUI.Library.Action.ActionType actionType)
		{
			if (control==listCountries)
			{
				GUIListItem item=listCountries.SelectedListItem;
				DoScan(item);
				GUIWindowManager.ActivateWindow((int)GUIWindow.Window.WINDOW_WIZARD_ANALOG_CITY);
				return;
			}
			if (control==btnManual)
			{
				GUIWindowManager.ActivateWindow((int)GUIWindow.Window.WINDOW_WIZARD_ANALOG_MANUAL_TUNE);
			}
			base.OnClicked (controlId, control, actionType);
		}

		void DoScan(GUIListItem item)
		{
			using (MediaPortal.Profile.Xml xmlwriter = new MediaPortal.Profile.Xml("MediaPortal.xml"))
			{
				xmlwriter.SetValue("capture", "countryname", item.Label);
				xmlwriter.SetValue("capture", "country", item.ItemId.ToString());
			}			
			GUIPropertyManager.SetProperty("#WizardCountry",item.Label);
		}

		public int Compare(object x, object y)
		{
			GUIListItem item1=(GUIListItem)x;
			GUIListItem item2=(GUIListItem)y;
			return String.Compare(item1.Label,item2.Label);
		}
	}
}
